define(function(require, exports) {
    var domains = g_data.domains; // 此处 domain 已经自带协议头

    /**
     * 判断URL是否合法
     */
    exports.isValid = function(str) {
        var strRegex = "^(http(s)?(:\/\/))?(www\.)?[a-zA-Z0-9-_\.]+";
        var re = new RegExp(strRegex);
        return re.test(str);

    };

    /**
     * 获得URL中的query值
     */
    exports.getParamByName = function(name, url) {
            if (!url) {
                url = window.location.href;
            }
            name = name.replace(/[\[\]]/g, "\\$&");
            var regex = new RegExp("[?&]" + name + "(=([^&#]*)|&|#|$)"),
                results = regex.exec(url);
            if (!results) return null;
            if (!results[2]) return '';
            return decodeURIComponent(results[2].replace(/\+/g, " "));
        },

        /**
         *  更新当前URL的query值
         */
        exports.setParam = function(param, paramVal, url) {
            if (!url) {
                url =  window.location.href;
            }
            var theAnchor = null;
            var newAdditionalURL = "";
            var tempArray = url.split("?");
            var baseURL = tempArray[0];
            var additionalURL = tempArray[1];
            var temp = "";

            if (additionalURL) {
                var tmpAnchor = additionalURL.split("#");
                var TheParams = tmpAnchor[0];
                theAnchor = tmpAnchor[1];
                if (theAnchor)
                    additionalURL = TheParams;

                tempArray = additionalURL.split("&");

                for (i = 0; i < tempArray.length; i++) {
                    if (tempArray[i].split('=')[0] != param) {
                        newAdditionalURL += temp + tempArray[i];
                        temp = "&";
                    }
                }
            } else {
                var tmpAnchor = baseURL.split("#");
                var TheParams = tmpAnchor[0];
                theAnchor = tmpAnchor[1];

                if (TheParams)
                    baseURL = TheParams;
            }

            if (theAnchor)
                paramVal += "#" + theAnchor;

            var rowsTxt = temp + "" + param + "=" + paramVal;
            return baseURL + "?" + newAdditionalURL + rowsTxt;
        }

});
